
/*
 * garux.h
 *
 * Linux Loader for the Palm OS.
 *
 * Copyright (C) 2005 Romain Goyet
 * Author: Romain Goyet [r.goyet@gmail.com]
 *
 * Original version by Vinayak R. Borkar [vinayakb@users.sourceforge.net]
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */


/* CAUTION : DO _never_ use the TOKEN below anywhere else in this file
 *  as this TOKEN is going to be dynamically replaced at compile time
 */

#ifndef __LOADLIN_H__
#define __LOADLIN_H__

#include <PalmOS.h>
#include <PceNativeCall.h>
#include "gui.h" // GUI headers
#include "mach.h" // Machine-specific headers


/* NUM_KERNEL_PAGES is the number of times PAGE_SIZE the kernel
 * will need. This is dynamically calculated at compile time
 */
#define NUM_KERNEL_PAGES 29
#define SIZE_KERNEL 924068
#define SIZE_INITRD 11139
#define PAGE_SIZE 0x8000

#endif
