#!/bin/sh

#
# Header generation
#
# Dynamic creation of garux.h and garux.rcp
#
# Copyright (C) 2005 Romain Goyet
# Author: Romain Goyet [r.goyet@gmail.com]
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
#NUM_PAGES=`ls -l image.bin | cut -f6 -d\ `

echo "Calculating constants..."
export NUM_PAGES=`du -b image.bin | cut -f1 -d\i`
export NUM_PAGES=`echo $NUM_PAGES/32768+1 | bc`
export RAM_BASE_ADDRESS=`cat mach.h | grep RAM_BASE_ADDRESS | cut -f3 -d\ `

export NUM_IMAGE=`ls -al image.bin |awk '{print $5}'`
export NUM_KERNEL=`ls -al zImage |awk '{print $5}'`

NUM_INITRD=0
if [ -f initrd.gz ]
then
NUM_INITRD=`ls -al initrd.gz |awk '{print $5}'`
fi

echo "Creating garux.h from garux-generic.h ..."
cat garux-generic.h | sed s/TOKEN_TO_REPLACE/$NUM_PAGES/ |sed s/KERNEL_TO_REPLACE/$NUM_KERNEL/ |sed s/INITRD_TO_REPLACE/$NUM_INITRD/ |sed s/IMAGE_TO_REPLACE/$NUM_IMAGE/ > garux.h

#cat garux-generic.h | sed s/TOKEN_TO_REPLACE/$NUM_PAGES/ > garux.h
# Next : Isn't needed : it includes garux.h
#cat garux-generic.rcp |sed s/INITRD_TO_REPLACE/$NUM_INITRD/ > garux.rcp
#cp garux-generic.rcp garux.rcp
echo -n > garux.rcp.cmd
echo -n "STRING kernelDefaultParam \"mem=" >> garux.rcp.cmd
echo -n `cat mach.h | grep PHYSICAL_RAM_SIZE | cut -f3 -d\ ` >> garux.rcp.cmd
echo -n " initrd=0x" >> garux.rcp.cmd
INITRD_BASE_ADDRESS=`echo $RAM_BASE_ADDRESS | cut -f2 -dx`
INITRD_BASE_ADDRESS=`echo "obase=16; ibase=16; $INITRD_BASE_ADDRESS + 0400000"|bc`
INITRD_SIZE=`echo "obase=16; ibase=10; $NUM_INITRD"|bc`
echo -n $INITRD_BASE_ADDRESS >> garux.rcp.cmd
echo -n ",0x$INITRD_SIZE root=/dev/ram0 init=/linuxrc\"" >> garux.rcp.cmd
NUM_IMAGE=`echo $NUM_IMAGE/1024 |bc`
echo "Num page " $NUM_PAGES
echo "Size image " $NUM_IMAGE
