/*
 * asmloader.c
 *
 * Linux Loader for the Palm OS.
 *
 * Copyright (C) 2004 Vinayak R. Borkar
 * Author: Vinayak R. Borkar [vinayakb@users.sourceforge.net]
 *
 * Original version by Romain Goyet [r.goyet@gmail.com]
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <PceNativeCall.h>
#include <Standalone.h>

#include "garux.h"
#include "graphics.h"
#define DEST 0x10008000
// #define COPY2
#define GREP

#ifdef GREP
#define DESTT 0x11800000
#else	/* GREP */
#ifdef COPY2
#define DESTT 0x11000000
#else	/* COPY2 */
#define DESTT 0x11080000
#endif	/* !COPY2 */
#endif	/* !GREP */

#define SET_TAG_WORD(off, value)	\
	*((unsigned long *) (0x10000100 + ((off) << 2))) = value
#define SET_TAG_WORD_BYTE(off, byte, value)	\
	*((char *) (0x10000100 + ((off) << 2) + (byte))) = value

STANDALONE_CODE_RESOURCE_ID (ID_ASMLOADER);

#define DEBUG(a) /*{ \
    unsigned long register __temp__; \
    for (__temp__ = 0; __temp__ < 1024; __temp__ += 4) { \
        *((unsigned long *) ((a) + __temp__)) = 0xffffffff; \
    } \
}*/////

void startKernel();
inline static void switch_mode();

unsigned long bootLinux(const void *emulStateP, char *userData68KP,
		Call68KFuncType *call68KFuncP) {
    unsigned long register i;
    unsigned long register j;
#ifndef GREP
    unsigned long register krnlSrc;
#else
    unsigned long register k;
#endif
    int byte = 0;
    char c, *cmdline;
#if 0
    volatile unsigned short v;
#endif

    cmdline = (char *) userData68KP;
#ifndef GREP
    krnlSrc = (unsigned long) (userData68KP + 256);
#endif

    // Disable FIQ, IRQ
    asm volatile ("mrs r0, cpsr");
    asm volatile ("orr r0, r0, #0xc0");
    asm volatile ("msr cpsr, r0");

    // Set Page table entries for 0x10000000 and 0x11000000 to identity.
    *((unsigned long *) 0x4400) = 0x10000c1a;
/*    *((unsigned long *) 0x4404) = 0x10100c1a;
    *((unsigned long *) 0x4408) = 0x10200c1a;
    *((unsigned long *) 0x440c) = 0x10300c1a;
    *((unsigned long *) 0x4410) = 0x10400c1a;
    *((unsigned long *) 0x4414) = 0x10500c1a;
    *((unsigned long *) 0x4418) = 0x10600c1a;
    *((unsigned long *) 0x441c) = 0x10700c1a;
    *((unsigned long *) 0x4420) = 0x10800c1a;
    *((unsigned long *) 0x4424) = 0x10900c1a;
    *((unsigned long *) 0x4428) = 0x10a00c1a;
    *((unsigned long *) 0x442c) = 0x10b00c1a;
    *((unsigned long *) 0x4430) = 0x10c00c1a;
    *((unsigned long *) 0x4434) = 0x10d00c1a;
    *((unsigned long *) 0x4438) = 0x10e00c1a;
    *((unsigned long *) 0x443c) = 0x10f00c1a;*/
    *((unsigned long *) 0x4440) = 0x11000c1a;
    *((unsigned long *) 0x4444) = 0x11100c1a;
    /*((unsigned long *) 0x4448) = 0x11200c1a;
    *((unsigned long *) 0x444c) = 0x11300c1a;
    *((unsigned long *) 0x4450) = 0x11400c1a;
    *((unsigned long *) 0x4454) = 0x11500c1a;
    *((unsigned long *) 0x4458) = 0x11600c1a;
    *((unsigned long *) 0x445c) = 0x11700c1a;
    *((unsigned long *) 0x4460) = 0x11800c1a;
    *((unsigned long *) 0x4464) = 0x11900c1a;
    *((unsigned long *) 0x4468) = 0x11a00c1a;
    *((unsigned long *) 0x446c) = 0x11b00c1a;
    *((unsigned long *) 0x4470) = 0x11c00c1a;
    *((unsigned long *) 0x4474) = 0x11d00c1a;
    *((unsigned long *) 0x4478) = 0x11e00c1a;
    *((unsigned long *) 0x447c) = 0x11f00c1a;*////

    *((unsigned long *) 0x4480) = 0xff000c1a;
    *((unsigned long *) 0x447c) = 0x11f00c1a;
    // Set Page table entries for 0x20000000 to identity.
    /**((unsigned long *) 0x4C00) = 0x20000c1a;*/

#define xomap_writew(x, y) *(unsigned short *) (y) = x
#define xomap_writel(x, y) *(unsigned long *) (y) = x
#define xomap_readw(y) (*(unsigned short *) (y))
#define xomap_readl(y) (*(unsigned long *) (y))
#define xomap_setw(addr, bit, wdth) xomap_writew(	\
		xomap_readw(addr) | (((1 << (wdth)) - 1) << (bit)), addr)
#define xomap_setl(addr, bit, wdth) xomap_writel(	\
		xomap_readw(addr) | (((1 << (wdth)) - 1) << (bit)), addr)

#define xomap_clrw(addr, bit, wdth) xomap_writew(	\
		xomap_readw(addr) & ~(((1 << (wdth)) - 1) << (bit)), addr)
#define xomap_clrl(addr, bit, wdth) xomap_writel(	\
		xomap_readw(addr) & ~(((1 << (wdth)) - 1) << (bit)), addr)

#define fb_base	(xomap_readw(0xfffedb02) | (xomap_readw(0xfffedb04) << 16))

	/* Disable TC interrupts */
	xomap_writew(0x0009, 0xfffed30c); /* ENHANCED_TIPB_CNTL pg: 106 */

	/* DMA_CCR/SYNC */
	for (i = 0; i < 9; i ++)
		xomap_clrw(0xfffed802 + 0x40 * i, 0, 5);
	for (i = 0; i < 1000000; i ++);

	/* Then disable the running channels.  */
	/* DMA_CCR/EN */
	for (i = 0; i < 9; i ++)
		xomap_clrw(0xfffed802 + 0x40 * i, 7, 1);

	/* LCD_CONTROL */
////	xomap_writew(0x0000, 0xfffec000);

    // Let's flush Instruction and Data cache
    asm volatile ("mov r0, #0");
    asm volatile ("mcr p15, 0, r0, c7, c7, 0");       // flush v3/v4 cache
    asm volatile ("mcr p15, 0, r0, c8, c7, 0");       // flush v4 TLB

    // Wait a bit.
    for (i = 0; i < 100000 ; i ++);

    DEBUG(0x11f08000);

#ifndef GREP
    // Copy the kernel to memory starting at 0x11000000
    // In reality we want to copy the image to 0x10008000, but that location
    // holds a second level page table. So if we try to copy directly to the
    // final destination, the system crashes due to a corrupted second level
    // page table. So we temporarily copy it way out into 0x11000000 first.
    // 
    // Assumption: 0x11000000 is way out and does not trample on either
    // the code or kernel data.
    for (i = 0; i < NUM_KERNEL_PAGES * PAGE_SIZE; i += 4) {
        *((unsigned long *) (DESTT + i)) =
		*((unsigned long *) (krnlSrc + i));
    }
#endif

    // Set the ATags
    i = 0;

    // ATAG_CORE
    SET_TAG_WORD(i ++, 0x00000002);
    SET_TAG_WORD(i ++, 0x54410001);

    // ATAG_MEM
    SET_TAG_WORD(i ++, 0x00000004);
    SET_TAG_WORD(i ++, 0x54410002);
    SET_TAG_WORD(i ++, 0x02000000);
    SET_TAG_WORD(i ++, 0x10000000);

    // ATAG_FB
    SET_TAG_WORD(i ++, 0x00000009);
    SET_TAG_WORD(i ++, 0xfbfbfbfb);
    SET_TAG_WORD(i ++, fb_base);
    SET_TAG_WORD(i ++, 0x00000028);
    SET_TAG_WORD(i ++, 0x00000028);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000008);
    SET_TAG_WORD(i ++, 0x00000010);////

    // ATAG_CMDLINE
    for (byte = 0; cmdline[byte]; byte ++);
    byte = (byte + 3) & ~3;
    SET_TAG_WORD(i ++, 0x00000002 + byte / 4);
    SET_TAG_WORD(i ++, 0x54410009);
    byte = 0;
    do {
        c = *cmdline ++;
        SET_TAG_WORD_BYTE(i, byte, c);
        if (++ byte == 4) {
		byte = 0; i ++;
	}
    } while (c);
    while (byte > 0) {
        SET_TAG_WORD_BYTE(i, byte, 0);
        if (++ byte == 4) {
		byte = 0; i ++;
	}
    }

    // ATAG_OMAP
    SET_TAG_WORD(i ++, 0x0000001b);
    SET_TAG_WORD(i ++, 0x414f4d50);
    SET_TAG_WORD(i ++, 0x00044f01);	/* OMAP_TAG_CLOCK */
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x000c4f02);	/* OMAP_TAG_MMC */
    SET_TAG_WORD(i ++, 0x00100000);
    SET_TAG_WORD(i ++, 0x00090001);
    SET_TAG_WORD(i ++, 0x000800c4);
    SET_TAG_WORD(i ++, 0x00244f05);	/* OMAP_TAG_LCD */
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x65746e69);
    SET_TAG_WORD(i ++, 0x6c616e72);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00100000);
    SET_TAG_WORD(i ++, 0x00184f82);	/* OMAP_TAG_VERSION_STR */
    SET_TAG_WORD(i ++, 0x6d6c6150);
    SET_TAG_WORD(i ++, 0x457c5420);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000031);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);


    // ATAG_NONE
    SET_TAG_WORD(i ++, 0x00000000);
    SET_TAG_WORD(i ++, 0x00000000);

	/*
	 * FIXME: We arbitrarily add 0x60 to pc and copy 2048 bytes starting
	 * from there. So if any code is modified between <CRITICAL>
	 * and </CRITICAL>, the offset needs to change.
	 * <CRITICAL>
	 */
	asm volatile ("add %0, pc, #0x60" : "=r" (j));
	for (i = 0; i < 2048; i ++) {
		*((char *) (0x10001000 + i)) = *((char *) (i + j));
	}

	DEBUG(0x11f09000);

	asm volatile ("mov lr,     #0x10000000");
	asm volatile ("add pc, lr, #0x00001000");

	/* </CRITICAL> */

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");

	/* Let's flush Instruction and Data cache */
	asm volatile ("mov r0, #0");
	asm volatile ("mcr p15, 0, r0, c7, c7, 0");	/* flush v3/v4 cache */
	asm volatile ("mcr p15, 0, r0, c8, c7, 0");	/* flush v4 TLB */

    // Wait a bit.
    for (i = 0; i < 100000; i ++);
    
    // Let's disable the MMU and disable data cache.
    asm volatile ("mrc p15, 0, r0, c1, c0, 0");
/*  asm volatile ("bic r0, r0, #0x00002300");  // clear bits 13, 9:8 (--V- --RS)
    asm volatile ("bic r0, r0, #0x00000087");  // clear bits 7, 2:0 (B--- -CAM)
*/  asm volatile ("bic r0, r0, #0x0000000f");
    asm volatile ("bic r0, r0, #0x00ff0000");
    asm volatile ("bic r0, r0, #0xff000000");
    asm volatile ("orr r0, r0, #0x00001000");  // set bit 12 (I) I-Cache
    asm volatile ("mcr p15, 0, r0, c1, c0, 0");

#ifdef GREP
    xomap_writel(fb_base, 0x10000000);
#undef fb_base
#define fb_base xomap_readl(0x10000000)
#define v0	j
#define v1	k
    COUNTER_INIT;

    for (i = 0x10000000; i < DESTT;) {
        if (*(uint32_t *) i == 0xcafebabe) {
            i += 4;
            if (*(uint8_t *) i != '0')
                continue;
            else
                *(uint32_t *) (i - 4) = 0xdeadbabe;
            j = *(uint8_t *) i ++ - '0';
            j *= 10;
            j += *(uint8_t *) i ++ - '0';
            j *= 10;
            j += *(uint8_t *) i ++ - '0';
            j *= 10;
            j += *(uint8_t *) i ++ - '0';
            j *= PAGE_SIZE - 8;
            j += DESTT;
            for (k = 8; k < PAGE_SIZE; i += 4, j += 4, k += 4)
                *(uint32_t *) j = *(uint32_t *) i;
            COUNTER_UPD(i, 0x10000000, DESTT);
        } else
            i += 4;
        if (!(i & 0xffff)) {
            COUNTER_UPD(i, 0x10000000, DESTT);
        }
    }
#endif
#ifdef COPY2
    // Wait a bit.
    for (i = 0; i < 100000; i ++);

    DEBUG(0x11f0a000);

    // Actually copy the kernel to 0x10008000.
    for (i = 0; i < NUM_KERNEL_PAGES * PAGE_SIZE; i += 4) {
        *((unsigned long *) (DEST + i)) =
		*((unsigned long *) (DESTT + i));
    }

    DEBUG(0x11f0b000);
#endif	/* COPY2 */

    // Wait a bit.
    for (i = 0; i < 10000000; i ++);

#define omap_writew(x, y) *(unsigned short *) (y) = x
#define omap_writel(x, y) *(unsigned long *) (y) = x
#define omap_readw(y) (*(unsigned short *) (y))
#define omap_readl(y) (*(unsigned long *) (y))
	/* DMA_GCR */
#define for(xx)
#if 0
	omap_writew(0x0008, 0xfffedc00);
	for (i = 0; i < 100000; i ++);
	/* DMA_CCR */
	/*for (i = 0; i < 9; i ++) {
		v = *(unsigned short *) (0xfffed802 + (i < 6));
		if (v & 0x80)
			*(unsigned short *) (0xfffed802 + (i < 6)) = v ^ 0x80;
	}*/
	omap_writew(0x0000, 0xfffed802);
	/*omap_writew(0x0000, 0xfffed842);
	omap_writew(0x0000, 0xfffed882);*/////
	omap_writew(0x0000, 0xfffed8c2);
	omap_writew(0x0000, 0xfffed902);
	omap_writew(0x0000, 0xfffed942);
	omap_writew(0x0000, 0xfffed982);
	omap_writew(0x0000, 0xfffed9c2);
	omap_writew(0x0000, 0xfffeda02);
	/* LCD */
	omap_writew(0x0000, 0xfffec000);
#endif
	for (i = 0; i < 100000; i ++);
	/*
	 * Resets:
	 * PWR_ON, MPU_RST,
	 * Global: SW_RST, ARM_RST, DSP_EN fields of the ARM_RSTCT1 register,
	 * MPU: signal_reset or ARM_RST of the ARM_RSTCT1 register,
	 * MCU: ,
	 * Watchdog: global.
	 */
	omap_writew(0x07ff, 0xfffece08);////IDLECT2
	for (i = 0; i < 100000; i ++);
	/* reset: omap_writew(0x0009, 0xfffece10); */ ////RSTCT1
	for (i = 0; i < 100000; i ++);
	/* omap_writew(0x0001, 0xfffece14); */	/* RSTCT2 */
	for (i = 0; i < 100000; i ++);
	omap_writew(0x03ff, 0xfffe0824); /* ULPD pg: 1185 */
	for (i = 0; i < 100000; i ++);

	switch_mode();
	//
	////omap_writew(0x0002, 0xfffecf00); /* DPLL1 pg: 1183 ?? */
	////omap_writew(0x2002, 0xfffecf00); /* DPLL1 pg: 1183 ?? */
	for (i = 0; i < 100000; i ++);
	////omap_writew(0x0000, 0xfffe0830); /* CLOCK_CTRL_REG pg: 1187 */
	for (i = 0; i < 100000; i ++);
	////omap_writew(0x3000, 0xfffece00); /* ARM_CKCTL pg: 1166 */
	for (i = 0; i < 100000; i ++);
	////omap_writew(0x0000, 0xfffece18); /* ARM_SYSST pg: 1176 */
	for (i = 0; i < 100000; i ++);
	/* Clock change: pg 94, 95, 96 ... */

/*	omap_writew(0x3000, 0xfffece00);*/
	////omap_writew(0x2002, 0xfffecf00);
	/*omap_writew(0x0000, 0xfffe100c); fix the pins first*/
	////omap_writel(0x0010fffb, 0xfffecc10);
	////omap_writel(0x00618800, 0xfffecc20);
	/*omap_writel(0x00000037, 0xfffecc24);*/
/*	omap_writew(0x3000, 0xfffece00);*/
/*	omap_writew(0x0100, 0xfffece08);*/
/*	omap_writew(0x0000, 0xfffece10);*/
/*	omap_writew(0x0000, 0xfffece14);*/	/*set the pwl after this*/
/*	omap_writew(0x0038, 0xfffece18);*/
/*	omap_writel(0x0003ff1b, 0xfffec900);*/
	/* TODO: turn off all DMA */
#if 0
#define uint8_t unsigned char
    for (i = 0; i < 10000000; i ++);
	*(uint8_t *) 0xfffb5804 = 0x01;
	i = 0x80;
	while (1) {
		i ++;
		if (i & 0x80)
			*(uint8_t *) 0xfffb5800 = (~i & 0x7f) << 1;
		else
			*(uint8_t *) 0xfffb5800 = (i & 0x7f) << 1;
		for (j = 0; j < 0x80000; j ++);
	}
#endif
#undef for
	/*
	 * TODO: check bits CONF_PDEN_NRESET_OUT_R (31),
	 * CONF_PDEN_MPU_NRESET_R (30) and CONF_PDEN_ARM_BOOT_R (27)
	 * of the PULL_DWN_CTRL_1 register and bit CONF_PDEN_NRESPWRON_R (11)
	 * of the PULL_DWN_CTRL_0 register and bits CONF_NRESET_OUT_R (11:9)
	 * and CONF_MPU_NRESET_R (8:6) of the FUNC_MUX_CTRL_9 register and
	 * bit CONF_ARM_BOOT_R (29:27) of the FUNC_MUX_CTRL_8 register and
	 * the CONF_NRESPWRON_R (5:3) bit of the FUNC_MUX_CTRL_4 register and
	 * bits OS_TYPE(15), NRESET_ENABLE (14), PWN_MASK_IN (13) and
	 * PWR_MASK_OUT(12) of the FUNC_MUX_CTRL_0 register.
	 */
////#define ALL
#ifdef ALL
	asm volatile ("mov     r5,     #0x00003000");
	asm volatile ("mov     r6,     #0xff000000");
	asm volatile ("orr     r6, r6, #0x00fe0000");
	asm volatile ("orr     r6, r6, #0x0000ce00");
	asm volatile ("mov     r0,     #0x00002000");
	asm volatile ("mov     r1,     #0xff000000");
	asm volatile ("orr     r1, r1, #0x00fe0000");
	asm volatile ("orr     r1, r1, #0x0000ce00");
	asm volatile ("orr     r1, r1, #0x00000018");
	asm volatile ("mov     r3,     #0");
	asm volatile ("mov     r2,     #0");
	asm volatile ("loop:");
	asm volatile ("cmp     r2,     #8");
	asm volatile ("streq   r5, [r6]");
	asm volatile ("cmp     r2,     #9");
	asm volatile ("streq   r0, [r1]");
	asm volatile ("add     r2, r2, #1");
	asm volatile ("cmp     r2,     #32");
	asm volatile ("bne     loop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");

	asm volatile ("ldr     r0, REG_PULL_DWN_CTRL_0");
	asm volatile ("ldr     r1, VAL_PULL_DWN_CTRL_0");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_PULL_DWN_CTRL_1");
	asm volatile ("ldr     r1, VAL_PULL_DWN_CTRL_1");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_PULL_DWN_CTRL_2");
	asm volatile ("ldr     r1, VAL_PULL_DWN_CTRL_2");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_PULL_DWN_CTRL_3");
	asm volatile ("ldr     r1, VAL_PULL_DWN_CTRL_3");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_4");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_4");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_5");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_5");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_6");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_6");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_7");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_7");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_8");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_8");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_9");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_9");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_A");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_A");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_B");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_B");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_C");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_C");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_FUNC_MUX_CTRL_D");
	asm volatile ("ldr     r1, VAL_FUNC_MUX_CTRL_D");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_VOLTAGE_CTRL_0");
	asm volatile ("ldr     r1, VAL_VOLTAGE_CTRL_0");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_TEST_DBG_CTRL_0");
	asm volatile ("ldr     r1, VAL_TEST_DBG_CTRL_0");
	asm volatile ("str     r1, [r0]");
	asm volatile ("ldr     r0, REG_MOD_CONF_CTRL_0");
	asm volatile ("ldr     r1, VAL_MOD_CONF_CTRL_0");
	asm volatile ("str     r1, [r0]");

	asm volatile ("ldr     r0, REG_COMP_MODE_CTRL_0");
	asm volatile ("ldr     r1, VAL_COMP_MODE_CTRL_0");
	asm volatile ("str     r1, [r0]");

	asm volatile ("ldr r0, REG_TC_IMIF_PRIO");
	asm volatile ("mov r1, #0x0");
	asm volatile ("str r1, [r0]");
	asm volatile ("ldr r0, REG_TC_EMIFS_PRIO");
	asm volatile ("str r1, [r0]");
	asm volatile ("ldr r0, REG_TC_EMIFF_PRIO");
	asm volatile ("str r1, [r0]");

	asm volatile ("ldr r0, REG_TC_EMIFS_CONFIG");
	asm volatile ("ldr r1, [r0]");
	asm volatile ("bic r1, r1, #0x08");
	asm volatile ("bic r1, r1, #0x01");
	asm volatile ("str r1, [r0]");

#define EN_WDTCK	0
#define EN_XORPCK	1
#define EN_PERCK	2
#define EN_LCDCK	3
#define EN_LBCK		4
#define EN_HSABCK	5
#define EN_APICK	6
#define EN_TIMCK	7
#define DMACK_REQ	8
#define EN_GPIOCK	9
#define EN_LBFREECK	10

#define OMAP1510_CLKS ((1<<EN_XORPCK)|(1<<EN_PERCK)|(1<<EN_TIMCK)|(1<<EN_GPIOCK))
	asm volatile ("mov r1, #0x00000200");
	asm volatile ("orr r1, r1, #0x00000086");
	asm volatile ("ldr r0, REG_ARM_IDLECT2");
	asm volatile ("strh r1, [r0]");

	asm volatile ("mov r1, #0x01");
	asm volatile ("ldr r0, REG_ARM_RSTCT2");
	asm volatile ("strh r1, [r0]");

	asm volatile ("mov r1, #0x1000");
	asm volatile ("ldr r0, REG_ARM_SYSST");
	asm volatile ("strh r1, [r0]");
	asm volatile ("mov r0, #0x400");
	asm volatile ("1:");
	asm volatile ("subs r0, r0, #0x1");
	asm volatile ("bne 1b");

	asm volatile ("ldr r1, VAL_ARM_CKCTL");
	asm volatile ("ldr r0, REG_ARM_CKCTL");
	asm volatile ("strh r1, [r0]");

	asm volatile ("ldr r1, VAL_DPLL1_CTL");
	asm volatile ("ldr r0, REG_DPLL1_CTL");
	asm volatile ("strh r1, [r0]");
	asm volatile ("ands r1, r1, #0x10");
	asm volatile ("beq lock_end");
	asm volatile ("2:");
	asm volatile ("ldrh r1, [r0]");
	asm volatile ("ands r1, r1, #0x01");
	asm volatile ("beq 2b");
	asm volatile ("lock_end:");

	asm volatile ("mov r0, #0x10000000");
	asm volatile ("mov r1, pc");
	asm volatile ("cmp r1, r0");
	asm volatile ("bge skip_sdram");

	asm volatile ("mov r3, #0x1800");
	asm volatile ("3:");
	asm volatile ("subs r3, r3, #0x1");
	asm volatile ("bne 3b");

	asm volatile ("ldr r0, VAL_TC_EMIFF_SDRAM_CONFIG");
	asm volatile ("bic r3, r0, #0xC");
	asm volatile ("orr r3, r3, #0x8000000");
	asm volatile ("orr r3, r3, #0x4000000");
	asm volatile ("ldr r2, REG_TC_EMIFF_SDRAM_CONFIG");
	asm volatile ("str r3, [r2]");

	asm volatile ("ldr r1, VAL_TC_EMIFF_MRS");
	asm volatile ("ldr r2, REG_TC_EMIFF_MRS");
	asm volatile ("str r1, [r2]");

	asm volatile ("ldr r2, REG_TC_EMIFF_SDRAM_CONFIG");
	asm volatile ("str r0, [r2]");

	asm volatile ("mov r3, #0x1800");
	asm volatile ("4:");
	asm volatile ("subs r3, r3, #1");
	asm volatile ("bne 4b");

	asm volatile ("skip_sdram:");
	asm volatile ("ldr r1, VAL_TC_EMIFS_CS0_CONFIG");
	asm volatile ("ldr r0, REG_TC_EMIFS_CS0_CONFIG");
	asm volatile ("str r1, [r0]");
	asm volatile ("ldr r1, VAL_TC_EMIFS_CS1_CONFIG");
	asm volatile ("ldr r0, REG_TC_EMIFS_CS1_CONFIG");
	asm volatile ("str r1, [r0]");
	asm volatile ("ldr r1, VAL_TC_EMIFS_CS2_CONFIG");
	asm volatile ("ldr r0, REG_TC_EMIFS_CS2_CONFIG");
	asm volatile ("str r1, [r0]");
	asm volatile ("ldr r1, VAL_TC_EMIFS_CS3_CONFIG");
	asm volatile ("ldr r0, REG_TC_EMIFS_CS3_CONFIG");
	asm volatile ("str r1, [r0]");

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("mrc p15, 0, r0, c1, c0, 0");
	asm volatile ("bic r0, r0, #0x0000000f");
	asm volatile ("bic r0, r0, #0x00001000");
	asm volatile ("bic r0, r0, #0x00ff0000");
	asm volatile ("bic r0, r0, #0xff000000");
	asm volatile ("mcr p15, 0, r0, c1, c0, 0");
	asm volatile ("mov r0, #0");
	asm volatile ("mcr p15, 0, r0, c7, c7, 0");
	asm volatile ("mcr p15, 0, r0, c8, c7, 0");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("mrs r0, cpsr");
	asm volatile ("bic r0, r0, #0x1f");
	asm volatile ("orr r0, r0, #0xd3");
	asm volatile ("msr cpsr, r0");
	asm volatile ("mov r1, #0x81");
	asm volatile ("mcr p15, 0, r1, c15, c1, 0");

        asm volatile ("mov  r1, #0xF5");
	asm volatile ("mov     r0,     #0xff000000");
	asm volatile ("orr     r0, r0, #0x00fe0000");
	asm volatile ("orr     r0, r0, #0x0000c800");
	asm volatile ("orr     r0, r0, #0x00000008");
	asm volatile ("strh r1, [r0]");
	asm volatile ("mov  r1, #0xA0");
	asm volatile ("strh r1, [r0]");

	asm volatile ("mov r1, #0xffffffff");
	asm volatile ("mov     r0,     #0xff000000");
	asm volatile ("orr     r0, r0, #0x00fe0000");
	asm volatile ("orr     r0, r0, #0x0000cb00");
	asm volatile ("orr     r0, r0, #0x00000004");
	asm volatile ("str r1, [r0]");
	asm volatile ("mov     r0,     #0xff000000");
	asm volatile ("orr     r0, r0, #0x00fe0000");
	asm volatile ("orr     r0, r0, #0x00000004");
	asm volatile ("str r1, [r0]");

	asm volatile ("mov     r0,     #0xff000000");
	asm volatile ("orr     r0, r0, #0x00fe0000");
	asm volatile ("orr     r0, r0, #0x0000cf00");
	asm volatile ("mov  r1, #0x10");
	asm volatile ("strh r1, [r0]");
	asm volatile ("poll1:");
	asm volatile ("ldrh r1, [r0]");
	asm volatile ("ands r1, r1, #0x01");
	asm volatile ("beq poll1");

	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");

	asm volatile ("mov     r0,     #0x000000ff");
	asm volatile ("mov     r1,     #0xff000000");
	asm volatile ("orr     r1, r1, #0x00fb0000");
	asm volatile ("orr     r1, r1, #0x00005800");
	asm volatile ("strb    r0, [r1]");
#endif

#if 1
#define omap_writeb(a, b) *(unsigned char *) (b) = (a)
#define omap_writew(a, b) *(unsigned short *) (b) = (a)
#define omap_writel(a, b) *(unsigned long *) (b) = (a)
	/* XXX: PWT */
	omap_writel(0, 0xfffb6004);
	omap_writel(0, 0xfffb6008);
	/* XXX: First LPG */
	omap_writeb(0, 0xfffbd000);
	omap_writeb(0, 0xfffbd004);
	/* XXX: Second LPG */
	omap_writeb(0, 0xfffbd800);
	omap_writeb(0, 0xfffbd804);
	/* XXX: USB Function */
	omap_writel(0, 0xfffb4018);
	/* XXX: USB Host */
	omap_writew(0, 0xfffec208);
	/* XXX: HDQ and 1-Wire Protocols */
	omap_writel(0, 0xfffbc008);
	/* XXX: Frame Adjustment Counter */
	omap_writew(0, 0xfffba800);
	omap_writew(0, 0xfffba808);
	/* XXX: uWire */
	omap_writew(0x0c00, 0xfffb3004);
	omap_writew(0x0000, 0xfffb3004);
	omap_writew(0, 0xfffb3010);
	omap_writew(0, 0xfffb3018);
#if 0
	/* XXX: MCSI1 */
	omap_writew(0, 0xe1012800);
	omap_writew(2, 0xe1012800);
	/* XXX: MCSI2 */
	omap_writew(0, 0xe1012000);
	omap_writew(2, 0xe1012000);
#endif
	/* XXX: McBSP1 */
	omap_writew(0, 0xe101180a);
	omap_writew(0, 0xe1011808);
	omap_writew(0x4000, 0xe1011824);
#if 0
	/* XXX: McBSP2 */
	omap_writew(0, 0xfffb100a);
	omap_writew(0, 0xfffb1008);
	omap_writew(0x4000, 0xfffb1024);
	/* XXX: McBSP3 */
	omap_writew(0, 0xe101700a);
	omap_writew(0, 0xe1017008);
	omap_writew(0x4000, 0xe1017024);
#endif
	/* XXX: Old I2C */
	omap_writew(1, 0xfffb3810);
	/* XXX: New I2C */
	omap_writew(0, 0xfffb3824);
	/* XXX: MMC */
	////omap_writew(0, 0xfffb780c);	/* Some card rely on this */
	/* XXX: USB Host & 32-kHz oscillator & MMC */
	omap_writel((omap_readl(0xfffe1080) & 0xf07ffdfe) | 0x08000000,
			0xfffe1080);

#if 0
	/* Temporarily disable LCD */
	omap_writel(0x0, 0xfffec000);
#endif
	/* Setup palette */
	omap_writew(0x3000, FB_BASE);
	for (i = 0x2; i < 0x200; i += 2)
		omap_writew(0x0ccc, FB_BASE + i);
	/* Setup DMA */
	omap_writew(0x0000, 0xfffedb00);
#if 0
	omap_writew(FB_BASE & 0xffff, 0xfffedb02);
	omap_writew(FB_BASE >> 16, 0xfffedb04);
	omap_writew((FB_BASE + 0x200 + 320 * 320) & 0xffff, 0xfffedb06);
	omap_writew((FB_BASE + 0x200 + 320 * 320) >> 16, 0xfffedb08);
	/* Setup LCD */

	omap_writel(0x1b070d3f, 0xfffec004);
	omap_writel(0x0708013f, 0xfffec008);
	omap_writel(0x00300004, 0xfffec00c);
	omap_writel(0xfeb10ce5, 0xfffec000);
#endif
#endif

	/* Initializing before boot.  */
	asm volatile ("mov r0,     #0");
	asm volatile ("mov r1,     #817&0xff");
	asm volatile ("orr r1, r1, #817&0xf00");
	asm volatile ("mov r2,     #0x10000000");
	asm volatile ("add r2, r2, #0x00000100");

	/* Jump to the kernel.  */
#ifdef COPY2
	asm volatile ("mov r3,     #0x00008000");	/* DEST */
	asm volatile ("orr r3, r3, #0x10000000");
#else	/* COPY2 */
#ifndef GREP
	asm volatile ("mov r3,     #0x00080000");	/* DESTT */
	asm volatile ("orr r3, r3, #0x11000000");
#else	/* !GREP */
	asm volatile ("mov r3,     #0x00800000");	/* DESTT */
	asm volatile ("orr r3, r3, #0x11000000");
#endif	/* GREP */
#endif	/* !COPY2 */
	asm volatile ("mov pc, r3");

	/*
	 * This needs to go before the "return", otherwise gcc will
	 * optimise it out as unreachable.
	 */
	asm volatile ("REG_FUNC_MUX_CTRL_0:");
	asm volatile (".word 0xfffe1000");
	asm volatile ("REG_FUNC_MUX_CTRL_1:");
	asm volatile (".word 0xfffe1004");
	asm volatile ("REG_FUNC_MUX_CTRL_2:");
	asm volatile (".word 0xfffe1008");
	asm volatile ("REG_COMP_MODE_CTRL_0:");
	asm volatile (".word 0xfffe100c");
	asm volatile ("REG_FUNC_MUX_CTRL_3:");
	asm volatile (".word 0xfffe1010");
	asm volatile ("REG_FUNC_MUX_CTRL_4:");
	asm volatile (".word 0xfffe1014");
	asm volatile ("REG_FUNC_MUX_CTRL_5:");
	asm volatile (".word 0xfffe1018");
	asm volatile ("REG_FUNC_MUX_CTRL_6:");
	asm volatile (".word 0xfffe101c");
	asm volatile ("REG_FUNC_MUX_CTRL_7:");
	asm volatile (".word 0xfffe1020");
	asm volatile ("REG_FUNC_MUX_CTRL_8:");
	asm volatile (".word 0xfffe1024");
	asm volatile ("REG_FUNC_MUX_CTRL_9:");
	asm volatile (".word 0xfffe1028");
	asm volatile ("REG_FUNC_MUX_CTRL_A:");
	asm volatile (".word 0xfffe102C");
	asm volatile ("REG_FUNC_MUX_CTRL_B:");
	asm volatile (".word 0xfffe1030");
	asm volatile ("REG_FUNC_MUX_CTRL_C:");
	asm volatile (".word 0xfffe1034");
	asm volatile ("REG_FUNC_MUX_CTRL_D:");
	asm volatile (".word 0xfffe1038");
	asm volatile ("REG_PULL_DWN_CTRL_0:");
	asm volatile (".word 0xfffe1040");
	asm volatile ("REG_PULL_DWN_CTRL_1:");
	asm volatile (".word 0xfffe1044");
	asm volatile ("REG_PULL_DWN_CTRL_2:");
	asm volatile (".word 0xfffe1048");
	asm volatile ("REG_PULL_DWN_CTRL_3:");
	asm volatile (".word 0xfffe104c");
	asm volatile ("REG_VOLTAGE_CTRL_0:");
	asm volatile (".word 0xfffe1060");
	asm volatile ("REG_TEST_DBG_CTRL_0:");
	asm volatile (".word 0xfffe1070");
	asm volatile ("REG_MOD_CONF_CTRL_0:");
	asm volatile (".word 0xfffe1080");
	asm volatile ("REG_TC_IMIF_PRIO:");
	asm volatile (".word 0xfffecc00");
	asm volatile ("REG_TC_EMIFS_PRIO:");
	asm volatile (".word 0xfffecc04");
	asm volatile ("REG_TC_EMIFF_PRIO:");
	asm volatile (".word 0xfffecc08");
	asm volatile ("REG_TC_EMIFS_CONFIG:");
	asm volatile (".word 0xfffecc0c");
	asm volatile ("REG_TC_EMIFS_CS0_CONFIG:");
	asm volatile (".word 0xfffecc10");
	asm volatile ("REG_TC_EMIFS_CS1_CONFIG:");
	asm volatile (".word 0xfffecc14");
	asm volatile ("REG_TC_EMIFS_CS2_CONFIG:");
	asm volatile (".word 0xfffecc18");
	asm volatile ("REG_TC_EMIFS_CS3_CONFIG:");
	asm volatile (".word 0xfffecc1c");
	asm volatile ("REG_TC_EMIFF_SDRAM_CONFIG:");
	asm volatile (".word 0xfffecc20");
	asm volatile ("REG_TC_EMIFF_MRS:");
	asm volatile (".word 0xfffecc24");
	asm volatile ("REG_ARM_CKCTL:");
	asm volatile (".word 0xfffece00");
	asm volatile ("REG_ARM_IDLECT2:");
	asm volatile (".word 0xfffece08");
	asm volatile ("REG_ARM_RSTCT2:");
	asm volatile (".word 0xfffece14");
	asm volatile ("REG_ARM_SYSST:");
	asm volatile (".word 0xfffece18");
	asm volatile ("REG_DPLL1_CTL:");
	asm volatile (".word 0xfffecf00");
	asm volatile ("REG_IDCODE:");
	asm volatile (".word 0xfffed404");
	asm volatile ("VAL_COMP_MODE_CTRL_0:");
	asm volatile (".word 0x0000eaef");
	asm volatile ("VAL_FUNC_MUX_CTRL_4:");
	asm volatile (".word 0x00000000");
	asm volatile ("VAL_FUNC_MUX_CTRL_5:");
	asm volatile (".word 0x00000000");
	asm volatile ("VAL_FUNC_MUX_CTRL_6:");
	asm volatile (".word 0x00000001");
	asm volatile ("VAL_FUNC_MUX_CTRL_7:");
	asm volatile (".word 0x00000000");
	asm volatile ("VAL_FUNC_MUX_CTRL_8:");
	asm volatile (".word 0x10001200");
	asm volatile ("VAL_FUNC_MUX_CTRL_9:");
	asm volatile (".word 0x01201012");
	asm volatile ("VAL_FUNC_MUX_CTRL_A:");
	asm volatile (".word 0x00000248");
	asm volatile ("VAL_FUNC_MUX_CTRL_B:");
	asm volatile (".word 0x00000248");
	asm volatile ("VAL_FUNC_MUX_CTRL_C:");
	asm volatile (".word 0x09000000");
	asm volatile ("VAL_FUNC_MUX_CTRL_D:");
	asm volatile (".word 0x00000000");
	asm volatile ("VAL_PULL_DWN_CTRL_0:");
	asm volatile (".word 0x11a10000");
	asm volatile ("VAL_PULL_DWN_CTRL_1:");
	asm volatile (".word 0x2e047fff");
	asm volatile ("VAL_PULL_DWN_CTRL_2:");
	asm volatile (".word 0xffd603a6");
	asm volatile ("VAL_PULL_DWN_CTRL_3:");
	asm volatile (".word 0x00003e03");
	asm volatile ("VAL_VOLTAGE_CTRL_0:");
	asm volatile (".word 0x00000007");
	asm volatile ("VAL_TEST_DBG_CTRL_0:");
	asm volatile (".word 0x00000007");
	asm volatile ("VAL_MOD_CONF_CTRL_0:");
	asm volatile (".word 0x0b000008");
	asm volatile ("VAL_ARM_CKCTL:");
	asm volatile (".word 0x010f");
	asm volatile ("VAL_DPLL1_CTL:");
	asm volatile (".word 0x2710");
	asm volatile ("VAL_TC_EMIFS_CS1_CONFIG_PRELIM:");
	asm volatile (".word 0x00001149");
	asm volatile ("VAL_TC_EMIFS_CS2_CONFIG_PRELIM:");
	asm volatile (".word 0x00004158");
	asm volatile ("VAL_TC_EMIFS_CS0_CONFIG:");
	asm volatile (".word 0x002130b0");
	asm volatile ("VAL_TC_EMIFS_CS1_CONFIG:");
	asm volatile (".word 0x0000f559");
	asm volatile ("VAL_TC_EMIFS_CS2_CONFIG:");
	asm volatile (".word 0x000055f0");
	asm volatile ("VAL_TC_EMIFS_CS3_CONFIG:");
	asm volatile (".word 0x00003331");
	asm volatile ("VAL_TC_EMIFF_SDRAM_CONFIG:");
	asm volatile (".word 0x010290fc");
	asm volatile ("VAL_TC_EMIFF_MRS:");
	asm volatile (".word 0x00000027");

	/* We should never get here... Just to make the compiler happy.  */
	return 0;
}

inline static void light(unsigned char level)  {
	register int i;

	*(unsigned char *) 0xfffb5804 = 0x01;
	*(unsigned char *) 0xfffb5800 = level;

	for (i = 0;  i < 1000000; i ++);
}

inline static void switch_mode() {
	register int i;

	light(0x88);

	/*
	 * Switch to fully synchronous mode.
	 * This is the plan:
	 * 1. Make sure DSP clock is enabled.
	 * 2. Make sure there are no active transfers on interfaces.
	 * 3. Make sure there are no active DSP transactions being performed.
	 * 4. Disable the MPU D-Cache and MMU.
	 * 5. Make sure the MPU-clock-control register (ARM_CKCTL), clock
	 *    dividers, and the DPLL_REG have correct contents for the clock
	 *    mode the system is being switched to:
	 *    i)   Program the DPLL to the desired frequency in synchronous
	 *         mode.
	 *    ii)  Program all clock-dividers to be equal.
	 *    iii) Change the clock mode to SYNC mode.
	 * 6. After the MPU write to the MPU-system-status register (ARM_SYSST)
	 *    (0x18) to switch modes, there must be no requests from the MPU
	 *    to the traffic controller for the next 100 MPU cycles (pg 95).
	 * 7. Make sure all read and write accesses to the clock-reset
	 *    registers are 16-bit accesses.
	 */
#define omap_setw(addr, bit, wdth) omap_writew(	\
		omap_readw(addr) | (((1 << (wdth)) - 1) << (bit)), addr)
#define omap_setl(addr, bit, wdth) omap_writel(	\
		omap_readw(addr) | (((1 << (wdth)) - 1) << (bit)), addr)

#define omap_clrw(addr, bit, wdth) omap_writew(	\
		omap_readw(addr) & ~(((1 << (wdth)) - 1) << (bit)), addr)
#define omap_clrl(addr, bit, wdth) omap_writel(	\
		omap_readw(addr) & ~(((1 << (wdth)) - 1) << (bit)), addr)

	/* Set TC strobe factors */
	omap_writew(0xff11, 0xfffed300); /* TIPB_CNTL pg: 106 */
	/* Disable TC interrupts */
	omap_writew(0x0009, 0xfffed30c); /* ENHANCED_TIPB_CNTL pg: 106 */

	/* 1. The DSP clock.  */

	/* ARM_SYSST/CLOCK_SELECT */
	/* ARM_CKCTL/DSPDIV */
///	omap_clrw(0xfffece00, 6, 2);
	/* ARM_CKCTL/EN_DSPCK */
///	omap_setw(0xfffece00, 13, 1);

	/* ARM_SYSST/CLOCK_SELECT */
	/* ARM_CKCTL/DSPMMUDIV */
///	omap_clrw(0xfffece00, 10, 2);
	/* ARM_CKCTL/EN_DSPCK */
///	omap_setw(0xfffece00, 13, 1);

	/* 2. Transfers on interfaces.  */

	/* Shutdown DMA channels and clock.  */
	/* DMA_GCR */
	omap_writew(0x0008, 0xfffedc00);
	/* ARM_SYSST/CLOCK_SELECT */
	/* ARM_CKCTL/TCDIV */
	/* ARM_IDLECT2/DMACK_REQ */
	omap_setw(0xfffece08, 8, 1);

	/* 3. There are no DSP transactions active.  */

	/* 4. Disable MMU and the D-Cache, but do enable I-Cache.  */

	/* 5. Program the clocks.  */
	/*
	 * Switching to fully synchronous mode:
	 *
	 * MPUDIV, DSPMMUDIV and TCDIV must be equal (divide-down bits),
	 * DSPMMUDIV must be 1x or 1/2x of DSPDIV.
	 * CLKGEN1 == CLKGEN3 == DPLL1/N,
	 * CLKGEN2 == DPLL1/O,
	 * CLKGEN2 == CLKGEN1 or
	 * CLKGEN1 * 2 == CLKGEN2,
	 * DSPMMU cannot run above the maximum speed of TC.
	 */
	/* ARM_CKCTL/ARMDIV */
//	omap_clrw(0xfffece00, 4, 2);
	/* ARM_CKCTL/DSPMMUDIV */
//	omap_clrw(0xfffece00, 10, 2);
	/* ARM_CKCTL/TCDIV */
//	omap_clrw(0xfffece00, 8, 2);
	/* ARM_CKCTL/PERDIV */
//	omap_clrw(0xfffece00, 0, 2);
	/* DPLL_CTL/PLL_MULT */
///	omap_clrw(0xfffecf00, 7, 5);
	/* DPLL_CTL/PLL_DIV */
///	omap_setw(0xfffecf00, 5, 2);
	/* DPLL_CTL/PLL_ENABLE */
///	omap_setw(0xfffecf00, 4, 1);

#if 0
/*	asm volatile (".code 16");
	asm volatile ("adr     r2,     into32bits");
	asm volatile ("bx      r2");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile (".code 32");
	asm volatile ("into32bits:");*/
	asm volatile ("mov     r4, r2");////
	
	asm volatile ("mov     r5,     #0x00003000");
	asm volatile ("mov     r6,     #0xff000000");
	asm volatile ("orr     r6, r6, #0x00fe0000");
	asm volatile ("orr     r6, r6, #0x0000ce00");
	asm volatile ("mov     r0,     #0x00002000");
	asm volatile ("mov     r1,     #0xff000000");
	asm volatile ("orr     r1, r1, #0x00fe0000");
	asm volatile ("orr     r1, r1, #0x0000ce00");
	asm volatile ("orr     r1, r1, #0x00000018");
	asm volatile ("mov     r3,     #0");
	asm volatile ("mov     r2,     #0");
	asm volatile ("loop:");
	asm volatile ("cmp     r2,     #8");
	asm volatile ("streq   r5, [r6]");
	asm volatile ("cmp     r2,     #9");
	asm volatile ("streq   r0, [r1]");
	asm volatile ("add     r2, r2, #1");
	asm volatile ("cmp     r2,     #32");
	asm volatile ("bne     loop");
	asm volatile ("adr     r2,     into16bits + 1");
	/*asm volatile ("bx      r2");
	asm volatile (".code 16");*/
	asm volatile ("into16bits:");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	asm volatile ("nop");
	/*asm volatile (".code 32");*/
	asm volatile ("mov     r2, r4");////
#endif

///	light(0xff);
}
