/*
 * garux.h
 *
 * Linux Loader for the Palm OS.
 *
 * Copyright (C) 2005 Romain Goyet
 * Author: Romain Goyet [r.goyet@gmail.com]
 *
 * Original version by Vinayak R. Borkar [vinayakb@users.sourceforge.net]
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */


/* CAUTION : DO _never_ use the TOKEN below anywhere else in this file
 *  as this TOKEN is going to be dynamically replaced at compile time
 */


#ifndef __LOADLIN_H__
#define __LOADLIN_H__

//UI Definitions :

// Forms
#define MainForm 1000
#define AltForm 1001

//Menu
#define MainMenu 1000

//Menu items
#define MenuAbout 1000
#define MenuQuit 1001

//Alerts
#define StartupAlert 1000

//Buttons
#define LinuxButton 9998
#define PalmOSButton 9999

//Strings
#define GnuGpl 1000
#define kernelDefaultParam 1001

//Fields
#define KernelParam 1000

//Bitmaps
#define Splash	1005

/* Resource IDs */
#define ID_ASMLOADER	0

#ifdef __GNUC__
typedef unsigned long uint32_t;
typedef unsigned short uint16_t;
typedef unsigned char uint8_t;

struct kernel_page_s {
	uint32_t offset;
	uint32_t size;
	uint32_t kernel_size;
	uint8_t payload[0];
};
#endif

#define DEVICE_RAM_BASE	0x10000000
#define DEVICE_RAM_SIZE	0x02000000

/* NUM_KERNEL_PAGES is the number of times PAGE_SIZE the kernel
 * will need. This is dynamically calculated at compile time
 */
#define NUM_KERNEL_PAGES TOKEN_TO_REPLACE
#define PAGE_SIZE 0x8000

#endif
